jQuery.each( [ "put", "delete" ], function( i, method ) {
  jQuery[ method ] = function( url, data, callback, type ) {
    if ( jQuery.isFunction( data ) ) {
      type = type || callback;
      callback = data;
      data = undefined;
    }
 
    return jQuery.ajax({
      url: url,
      type: method,
      dataType: type,
      data: data,
      success: callback
    });
  };
});
Date.prototype.format = function(fmt) {
    var o = { 
       "M+" : this.getMonth()+1,                 //月份 
       "d+" : this.getDate(),                    //日 
       "h+" : this.getHours(),                   //小时 
       "m+" : this.getMinutes(),                 //分 
       "s+" : this.getSeconds(),                 //秒 
       "q+" : Math.floor((this.getMonth()+3)/3), //季度 
       "S"  : this.getMilliseconds()             //毫秒 
   }; 
   if(/(y+)/.test(fmt)) {
           fmt=fmt.replace(RegExp.$1, (this.getFullYear()+"").substr(4 - RegExp.$1.length)); 
   }
    for(var k in o) {
       if(new RegExp("("+ k +")").test(fmt)){
            fmt = fmt.replace(RegExp.$1, (RegExp.$1.length==1) ? (o[k]) : (("00"+ o[k]).substr((""+ o[k]).length)));
        }
    }
   return fmt; 
}

$(function(){
	fillCommon();
	setInterval('fillCommon()',3000)
	$("#copyright").append(
		"<a href='http://smark.freecoop.net/'>Copyright @ PNMS </a> (demo system)");
});

function fillCommon(){ //fill header tips
	$.get("/api/alarm/statistic",function(rs){
		if(rs.code==0){
			var data = rs.data;
			$("#total_alarm").empty().append(data.total);
			$("#deviceAlarm").empty().append(data.deviceLevel);
			$("#portAlarm").empty().append(data.portLevel);
		}
	});
	
}

function byte2Readable(value,unit){
	switch (unit) {
	case "k","K":
		return value/1024;
	case "m","M":
		return value/1024/1024;
	case "G","g":
		return value/1024/1024/1024;
	default:
		return value;
	}
}

function fetchQStr(p, str) {
    var patt = new RegExp(p);
    if (patt.test(str)) {
        return str.replace(patt, "");
    } else {
        return "";
    }
}


function kv(k,v) {
	return k+": "+v+"<br>";
}

function dFormat(date) {
    return new Date(date).format("yyyy/MM/dd hh:mm:ss")
}

function isEmpty(str){
	return str =="" || str ==undefined;
}
