var dateFormater = "yyyy/MM/dd hh:mm:ss";
var table;
var deviceGroup = {};
var dataSet = [];
$(function() {
	loadData();
});
function openAddDeviceDialog(){
	$("#dialogTitle").empty().append("添加新设备")
	 $("#addMsg").empty();
	 $("#addIP").val("");
	 $("#addIP").removeAttr("disabled");
	 $("#addCommunity").val("");
	 $("#addName").val("");
	 $("#saveAction").val("add");
	 $('#addDeviceDialog').modal();
}
function openEditDeviceDialog(device) {
	console.log(device)
	$("#dialogTitle").empty().append("编辑设备信息")
	$("#addMsg").empty();
	$("#addIP").val(device.IP);
	$("#addIP").attr("disabled","disabled");
	$("#addCommunity").val(device.community);
	$("#addName").val(device.name);
	$("#saveAction").val("update");
	$("input:radio[value="+device.detectType+"]").attr('checked', 'true')
	loadDeviceGroup(device.groupID)
	//$("#group-list-tool").val(device.groupID)
	//$("#group-list-tool").find('option').eq(device.groupID).attr('selected', true);
	$('#addDeviceDialog').modal();
}

function snmpPing(){
	//var rs = $("#addDeviceForm").validator();
	var ip = $("#addIP").val().trim();
	var community = $("#addCommunity").val().trim();
	if(ip==null||community==null){
		alert("请填写有效IP和community")
	}
	$("#addMsg").empty().append("正在尝试Ping ...");
	$.post("/api/device/snmpPing",{"ip":ip,"community":community},function(rs){
		var img = "assets/img/ok64.png"
		if (rs.code!=0) {
			img = "assets/img/err64.png"
		}
		var msg = "<img src='"+img+"' style='height: 24px;'>"+rs.msg+" - "+new Date().format(dateFormater);

		$("#addMsg").empty().append(msg);
	})
}
function saveDevice(){
	var ip = $("#addIP").val().trim();
	var community = $("#addCommunity").val().trim();
	var groupId = $("#group-list-tool option:selected").val();
	var offline = "";//$("offline :checked").val();
	var name = $("#addName").val().trim();
	var detectType = $("input[name=detectType]:checked").val();
	var params = {"ip":ip,"community":community,"groupID":groupId,"offline":offline,"name":name,"detectType":detectType};
	console.log(params)
	$("#addMsg").empty().append("正在尝试添加设备");
	var action = "/api/device/"+$("#saveAction").val();
	console.log(action)
	$.post(action,params,function(rs){
		console.log(rs);
		$("#addMsg").empty().append(rs.msg);
		if(rs.code==0){
			if("add"==action){
				table.row.add(buildRow(rs.data)).draw();
			}else{
				table.row('.selected').data(buildRow(rs.data)).draw();
			}
			 $('#addDeviceDialog').modal('close');
		}
	})
}
function syncDevice(device) {
	$.post("/api/device/sync",{"ip":device.IP},function(rs){
		if(rs.code==0){
			alert("同步成功")
			loadData();
		}else{
			alert("同步失败："+rs.msg)
		}
	})
}
function loadData(){
	//load device group
	loadDeviceGroup();
	//load device types
	$.get("/api/device/allTypes",function(rs){
		if(rs.code==0){
			var data = rs.data;
			var html = "<option value=' '>所有类型</option>";
			for (var i = 0; i < data.length; i++) {
				var o = data[i];
				html += "<option value='"+o+"'>"+o+"</option>";
			}
			$("#type-list").empty().append(html);
		}
	});
	//load device data
	$.get("/api/device/all",function(rs){
		if(rs.code==0){
			showDeviceList(rs.data);
		}
	});
	
}
function deleteDevice(device){
	$("#willDeleteDevice").empty().append(device.name+"("+device.IP+")");
	$("#willDeleteIP").empty().append(device.IP);
	$('#my-confirm').modal({
        relatedTarget: this,
        onConfirm: function(options) {
        	var ip = $("#willDeleteIP").text();
        	$.post("/api/device/remove",{"ip":ip},function(rs){
        		if(rs.code!=0){
        			alert(rs.msg);
        		}else{
							table.row(".selected").remove().draw();
        		}
        	});
        },
        // closeOnConfirm: false,
        onCancel: function() {
        }
      });
}
function searchDevice(){
	var groupId = $("#group-list option:selected").val().trim();
	var deviceType = $("#type-list option:selected").val().trim();
	var opt = $("#queryStr").val();
	var ip = fetchQStr("^ip:",opt) ;
	var name = fetchQStr("^name\:",opt) ;
	if (ip==""&&name=="") {
		name = opt;
	}
	var params = {"groupId":groupId,"deviceType":deviceType,"ip":ip,"name":name};
	console.log(params)
	$.get("/api/device/search",params,function(rs){
		console.log(rs)
		if(rs.code==0){
			var data = rs.data;
			showDeviceList(data);
		}else{
			alert(rs.msg);
		}
	})
}

function showDeviceList(data) {
	for (var i = 0; i < data.length; i++) {
		var o = data[i];
		dataSet.push(buildRow(o))
	}
	if(table != undefined) {
		table.fnDestroy();
	}
	table = $('#deviceTable').DataTable( {
		oLanguage:{
            "sUrl": "assets/dataTable/i18n/Chinese.json"
        },
	    data: dataSet,
	    createdRow:function ( row, data, index ) {
			if ("掉线"==data[3]) {
				 $('td', row).eq(3).addClass('offline');
			}else{
			}
		}
	});
	$('#deviceTable tbody').on( 'mouseover', 'tr', function () {
        if ( $(this).hasClass('selected') ) {
            //$(this).removeClass('selected');
        }else {
            table.$('tr.selected').removeClass('selected');
			$(this).addClass('selected');
        }
	} );
	$('#deviceTable tbody').on( 'dblclick', 'tr', function () {
		var data = table.row(".selected").data()
		ip = data[1]
		showDeviceDetail(ip)
		
    } );	
}
function showActions(actionId,v) {
	//$("#"+actionId).css("display",v)
}
function loadDeviceGroup(selected) {
	$.get("/api/group/allDeviceGroup",function(rs){
		if(rs.code==0){
			var data = rs.data;
			var html = "<option value=' '>所有分组</option>";
			var html2 = "<option value=' '>未选分组</option>";
			var select = "";
			for (var i = 0; i < data.length; i++) {
				var o = data[i];
				if(o.id == selected){
					select = "selected"
				}else{
					select = "";
				}
				html += "<option value='"+o.id+"'"+select+">"+o.name+"</option>";
				html2 += "<option value='"+o.id+"'"+select+">"+o.name+"</option>";
			}
			$("#group-list").empty().append(html);
			$("#group-list-tool").empty().append(html2);
		}
	});
}

function buildRow(o){
		var online = true==o.online?"在线":"掉线";
		var jo = JSON.stringify(o);
		var group = o.groupID;
		group = group==null?"":group.substring(0,group.length-2);
		var actionId = "action-"+o.id;
		var isMonitor = o.monitor?"<i class='icon-switch-on' onclick='setMonitor("+jo+",false)'></i>":
						"<i class='icon-switch-off' onclick='setMonitor("+jo+",true)'></i>";
		var action = "<td id='"+actionId+"' style='display:;'><div class='tpl-table-black-operation'>"+
						"<a href='javascript:;' onclick='openEditDeviceDialog("+jo+")'>"+
							"<i class='am-icon-pencil'></i> 编辑"+
						"</a>"+
						"<a href='javascript:;' onclick='syncDevice("+jo+")'>"+
							"<i class='am-icon-pencil'></i> 同步"+
						"</a>"+
						"<a href='javascript:;' onclick='deleteDevice("+jo+")' class=''>"+
							"<i class='am-icon-trash'></i> 删除"+
						"</a>"+
					"</div></td>";
		row = [o.name,o.IP,o.type,online,group,dFormat(o.createTime),dFormat(o.syncTime),isMonitor,
			o.community,action];
		return row
}

function setMonitor(device,c){
	data = table.row('.selected').data();
	var params = {"id":device.IP,"monitor":c}
	$.post("/api/device/setMonitor",params,function(rs){
		if(rs.code == 0 ){
			o = rs.data;
			if(c){
				o.monitor =true;
				
			}else{
				o.monitor =false;
			}
			table.row('.selected').data(buildRow(o)).draw();
		}else{
			alert("操作失败请联系管理员")
		}
	})
}
function showDeviceDetail(ip) {
	$.get("/api/device/one",{"ip":ip},function(rs) {
		if (rs.code==0) {
			var device = rs.data;
			var online = true==device.online?"在线":"掉线";
			var group = device.groupID;
			group = group==null?"":group.substring(0,group.length-2);
			var descr = device.description;
			new jBox('Modal', {
				content: kv("设备名",device.name)+
						 kv("设备IP",device.IP)+
						 kv("设备类型",device.type)+
						 kv("是否在线",device.online?"是":"否")+
						 kv("分组",group)+
						 kv("创建时间",dFormat(device.createTime))+
						 kv("同步时间",dFormat(device.syncTime))+
						 kv("描述",descr)+
						 kv("Community",device.community)
            }).open();
		}else{
			alert("获取详细信息时出错")
		}
	})
}