var dateFormater = "yyyy/MM/dd hh:mm:ss";
$(function(){
	loadData();
	loadServerInfo();
	 setInterval('loadData()',10000)
	//$('#qrcode').qrcode({/*width: 64,height: 64,*/text:window.location.href});
});
function loadData(){
	
	$.post("/api/device/statistic",function(rs){
		if(rs.code==0){
			var data = rs.data;
			$("#totalDevice").empty().append(data.total);
			$("#onlineDevice").empty().append(data.online);
			$("#offlineDevice").empty().append(data.offline);
			$("#utDevice").empty().append(new Date().format(dateFormater));
		}
	});
	$.post("/api/port/statistic",function(rs){
		if(rs.code==0){
			var data = rs.data;
			$("#totalPort").empty().append(data.total);
			$("#validPort").empty().append(data.up);
			$("#downPort").empty().append(data.down);
			$("#utPort").empty().append(new Date().format(dateFormater));
		}
	});
	$.get("/api/summary/serverCPUMemLoad",function(rs){
		if(rs.code==0){
			var data = rs.data;
			$("#cpuMax").empty().append(data.max);
			$('#cpuMaxPro').attr('style',"width: "+data.max+"%;");
			$("#cpuAvg").empty().append(data.avg);
			$('#cpuAvgPro').attr('style',"width: "+data.avg+"%;");
			$("#processorCount").empty().append(data.counter);
		}else{
			console.log(rs)
		}
	});
	$.get("/api/summary/serverStorageLoad",function(rs){
		if(rs.code==0){
			var data = rs.data;
			var html = "";
			for (var i = 0; i < data.length; i++) {
				var o = data[i];
				html += "<tr><td>"+o.descr+"</td>" +
							"<td>"+byte2Readable((o.size*o.units),"g").toFixed(2)+"</td>"+
							"<td>"+byte2Readable((o.used*o.units),"g").toFixed(2)+"</td>"+
							"<td>"+o.units+"</td>"+
							"<td>"+((o.used/o.size)*100).toFixed(2)+"%</td>"+
						"</tr>";
			}
			$("#storage").empty().append(html);
		}else{
			console.log(rs)
		}
	});
}
function loadServerInfo(){
	$.get("/api/summary/serverInfo",function(rs){
		if(rs.code == 0){
			device = rs.data;
			$("#serverIp").empty().append(device.IP);
			$("#serverName").empty().append(device.name);
			$("#serverType").empty().append(device.type);
			$("#serverDescr").empty().append(device.description);
			$("#serverOid").empty().append(device.oid);
		}
	});
}
function byte2Readable(value,unit){
	switch (unit) {
	case "m","M":
		return value/1024/1024;
	case "G","g":
		return value/1024/1024/1024;
	default:
		return value;
	}
}