var DIR = 'assets/device-icons/default/';
var EDGE_LENGTH_MAIN = 150;
var EDGE_LENGTH_SUB = 50;

var edges = null;
var network = null;
var nodes = [{id:"10.10.1.5",label:"",name:"Test",shape:"image",image:"linux.png"}] ;
var positions ={};
var slinks = [];
slinks.push({
	id: "10.10.1.1:10.10.1.5",
	label: ""
});

// Called when the Visualization API is loaded.
function showTopology(options) {
	var nodesSet = new vis.DataSet();
	for (var i = 0; i <nodes.length; i++) {
		var node = nodes[i];
		var label = node.label;
		node.label = label==""?node.name:label;
		var image = node.image;
		node.image = image==""?DIR+"unkown.png":DIR+node.image;
		node.title="Type: "+node.type;
		node.shape = "image";
		var ps = positions[node.id];
		if(ps != undefined && ps !=null){
			node.x = ps.x;
			node.y = ps.y;
		}
		console.log(ps)
		nodesSet.add(node)
	}
	// Create a data table with nodes.

	//	for(var i = 0; i < slinks.length; i++) {
	//		var link = slinks[i];
	//		var ft = link.id.split(":");
	//		link.from = ft[0];
	//		link.to = ft[1];
	//		if(link.mlabel !=undefined){
	//			link.label = link.mlabel;
	//		}
	//		edges.push(link)
	//	}

	// create a network
	visData = {
		nodes:nodes
	}
	var container = document.getElementById('topology');
	network = new vis.Network(container, visData, options);
	network.on("click", function(e) {
		console.log(network.nodes)
		console.log(network.getPositions())
		console.log(node)
	})
	network.on("blurPopou", function(e) {
		console.log(network.nodes)
		console.log(network.getPositions())
		console.log(node)
	})
	 
}
var options = {
	interaction:{hover:true},
	autoResize: false,
	height: '100%',
	width: '100%',
	physics: {
		enabled: false
	},
	nodes:{
		font:{color:"#868E8E"}
	}
} 

$(function() {
	//showTopology(options)
	$.get("/api/topo/default", function(rs) {
		if(rs.code != 0) {
			alert(rs.msg)
		} else {
			var data = rs.data;
			console.log(rs)
			if(data != null) {
				$("#topoName").empty().append(data.name)
				if(data.options != "") {
					options = JSON.parse(data.options);
				}
				if(data.positions!=undefined && ""!=data.positions){
					positions = JSON.parse(data.positions);
				}
				if(data.nodes != "") {
					nodes = data.nodes;
				}
			}
			showTopology(options)

		}

	})
})

function saveTopoConfig(){
	var positions = JSON.stringify(network.getPositions());
	console.log(positions)
	$.post("/api/topo/save",{"positions":positions},function(rs){
		if(rs.code==""){
			alert("成功保存")
		}else{
			alert(rs.msg)
		}
	})

}
