
var table;
var dataSet = [];
function loadAllAlarm() {
	$.get("/api/alarm/getAllAlarm", function(rs) {
		if(rs.code == 0) {
			var data = rs.data;
			console.log(data)
			var html = "";
			for(var i in data) {
				var o = data[i];
				buildRow(o)
			}
		} else {
			alert(rs.msg);
		}
		if(table != undefined) {
			table.fnDestroy();
		}
		table = $('#alarmTable').DataTable({
			oLanguage: {
				"sUrl": "assets/dataTable/i18n/Chinese.json"
			},
			columnDefs: [
				{"targets": [0],"visible": false}
			],
			aLengthMenu:[20,50,100],
			scrollY:        '55vh',
			scrollCollapse: true,
			paging:         false,
			data: dataSet
		});
		$('#alarmTable tbody').on( 'mouseover', 'tr', function () {
	        if ( $(this).hasClass('selected') ) {
	            //$(this).removeClass('selected');
	        }else {
	            //table.$('tr.selected').removeClass('selected');
	            //$(this).addClass('selected');
	        }
			} );
		$('#alarmTable tbody').on( 'dblclick', 'tr', function () {
			//$(this).toggleClass('selected');
			var data = table.row(".selected").data();
			if (data != undefined){
				showAlarmDetail(data[0]);
			}
		} );
		$('#alarmTable tbody').on( 'click', 'tr', function () {
			$(this).toggleClass('selected');
			var data = table.rows(".selected").data();
			if(data==undefined){
				data = [];
			}
			app.selectedAlarms = data;
		} );
	})
}
function buildRow(o){
		var row = [o.id,o.displayName,o.aom,o.deviceName,o.deviceIp,dFormat(o.createTime)
		,dFormat(o.updateTime),o.createBy];
		dataSet.push(row)
}

function showAlarmDetail(id) {
	$.get("/api/alarm/one",{"id":id},function(rs) {
		if (rs.code==0) {
			var alarm = rs.data;
			new jBox('Modal', {
				content: kv("告警名",alarm.displayName)+
						 kv("设备名",alarm.deviceName)+
						 kv("设备IP",alarm.deviceIp)+
						 kv("影响对象",alarm.aom)+
						 kv("创建时间",dFormat(alarm.createTime))+
						 kv("创建者",alarm.createBy)+
						 kv("更新时间",dFormat(alarm.updateTime))+
						 kv("更新者",alarm.updateBy)+
						 kv("描述",alarm.description)
            }).open();
		}else{
			alert("获取详细信息时出错")
		}
	})
}