var table;
var dataSet = [];
$(function() {
    table =$('#deviceTable').dataTable({});
	loadData();
});

function openAddGroupDialog(){
	 $('#add-group-dialog').modal();
}

function addGroup(){
	var name = $("#addName").val().trim();
	var type = $("#addType").val().trim();
	
	$.post("/api/group/add",{"name":name,"type":type},function(rs){
		$("#addMsg").empty().append(rs.msg);
		if(rs.code==0){
			table.row.add(buildRow(rs.data)).draw();
			 $('#add-group-dialog').modal('close');
		}else{
			alert(rs.msg)
		}
	})
}
function loadData(){
	$.get("/api/group/all",function(rs){
		if(rs.code==0){
			var data = rs.data;
			showGroupData(data);
		}
	});
}
function searchGroup(){
	var type = $("#i-group-type").val();
	var name = $("#i-group-name").val();
	if(name==null)name="";
	$.post("/api/group/search",{"type":type,"name":name},function(rs){
		if(rs.code==0){
			var data = rs.data;
			showGroupData(data);
		}
	});
}

function showGroupData(data){
	var html = "";
	for (var i = 0; i < data.length; i++) {
		var o = data[i];
		dataSet.push(buildRow(o));
	}
	if(table != undefined) {
		table.fnDestroy();
	}
	table = $('#groupTable').DataTable( {
		oLanguage:{
            "sUrl": "assets/dataTable/i18n/Chinese.json"
        },
	    data: dataSet
	});
	$('#groupTable tbody').on( 'mouseover', 'tr', function () {
        if ( $(this).hasClass('selected') ) {
            //$(this).removeClass('selected');
        }else {
            table.$('tr.selected').removeClass('selected');
            $(this).addClass('selected');
        }
    } );	
}
function buildRow(o){
	var type= "";
	switch (o.type) {
	case 1:
		type ="<i class='icon-device'></i>设备";
		break;
	case 2:
		type ="<i class='icon-port'></i>端口";
		break;
	}
	html = "<div class='tpl-table-black-operation'>"+
					"<a href='javascript:;' onclick='deleteGroup("+JSON.stringify(o)+")' class='tpl-table-black-operation-del'>"+
						"<i class='am-icon-'></i> 删除"+
					"</a>"+
				"</div>";
	var row = [o.name,type,html];
	return row;

}
function deleteGroup(o){
	$("#willDeleteGroup").empty().append(o.name);
	$("#willDeleteId").empty().append(o.id);
	$('#delete-confirm').modal({
        relatedTarget: this,
        onConfirm: function(options) {
        	var id = $("#willDeleteId").text();
        	$.post("/api/group/remove",{"id":id},function(rs){
        		if(rs.code!=0){
        			alert(rs.msg);
        		}else{
        			table.row(".selected").remove().draw();
        		}
        	});
        },
        // closeOnConfirm: false,
        onCancel: function() {
        }
      });
}
